#!/usr/bin/perl
#
#  Program expects a file containing pithy words
#   of wisdom.  Format of file is: text {/ text}* {| Author_citation}\n
#
# If the author citation is left out, then program  uses Anonymous.
# Optional / characters force line breaks, as would be appropriate for 
# verses. 
#

use strict;
use warnings;
use vars qw/$VERSION/;
use CGI qw/:standard/;
print header;
use Text::Wrap;
use Carp qw(cluck);  
use CGI::Carp qw(fatalsToBrowser set_message);  # Copy errors to client as well as to httpd error_log

           BEGIN {
              sub handle_errors {
                 my $msg = shift;
		 print qq[<BODY TEXT="#000000" BGCOLOR="#CCCCCC" LINK="#0000EF" 
		     VLINK="#51188E" ALINK="#FF0000">];
                 print "<h2>Problem with CGI processing, please report to the Webmaster.</h2><HR><BK><BK>";
                 print "Error: $msg";
             }
             set_message(\&handle_errors);
           }

# Print out the warnings to the log
local $SIG{__WARN__} = \&Carp::cluck;

######################
## File Locations   ##

my $TARGET_FILE = "/home/walt/public_html/cgi-bin/aphorisms";
my $TEMPLATE = "/home/walt/public_html/cgi-bin/WisdomQuote.tt";

                   ##  
#####################         

$VERSION = '2.0';


# Initialize

my $LINE_LN = 500;
    $Text::Wrap::columns = $LINE_LN;

    my ($work_line, $raw_body, $pretty_body, @pretty_body, $raw_sig, $pretty_sig,  @pretty_sig);
    my ($LINES, $PICK);

# Check for aphorisms file

    if (-r $TARGET_FILE) {

	srand(time);
	$LINES = `wc $TARGET_FILE`;
	chomp($LINES);
	$LINES =~ s/^\s*(\d+)\s.*/$1/;
	$PICK = int(rand($LINES)+1);

    } else {

	die "Can't find $TARGET_FILE anywhere... I'm bailing out.\n";

    }

    open (INP, "<$TARGET_FILE");

    for (my $i = 1; $i < $PICK; $i++) {

	my $trash = <INP>;

    }

$work_line = <INP>;
chomp($work_line);
close INP;

# Make Pretty

if ($work_line =~ /\|/) {   # Has Sig line?

    ($raw_body, $raw_sig)= split(/\|/, $work_line);

} else {  # Nope -- make anonymous

    $raw_body = $work_line;
    $raw_sig = "Anonymous";
}

    $raw_body =~ s/\//\n\n/g;

    @pretty_body = $raw_body;
    @pretty_sig = split(/\//,$raw_sig);

# Format it

    $pretty_body = fill("","\t",@pretty_body);
    $pretty_body =~ s|\n|<br>|g;

    $pretty_sig = fill("\t","\t\t",@pretty_sig);
 

## Generate  HTML page

open (TMP, "<$TEMPLATE");

while (<TMP>) {
     s/\[% QuoteBody %\]/$pretty_body/;
     s/\[% QuoteAuthor %\]/$pretty_sig/;
    print;
}

close;



1;
